<?php

namespace FiloBlu\Esb\Model;

use FiloBlu\Esb\Api\Data\ConsumerInterface;
use FiloBlu\Esb\Api\ConsumerResolverInterface;

/**
 * Class ConsumerResolver
 * @package FiloBlu\Esb\Model
 */
class ConsumerResolver implements ConsumerResolverInterface {
    /**
     * @var array
     */
    protected $consumers = [];

    /**
     * ConsumerResolver constructor.
     * @param array $consumers
     */
    public function __construct(array $consumers = [])
    {
        $this->consumers = $consumers;
    }

    /**
     * @param string $identifier
     * @return ConsumerInterface
     */
    public function get($identifier) : ConsumerInterface
    {
        return $this->consumers[$identifier];
    }

    /**
     * @param string $identifier
     * @return boolean
     */
    public function has($identifier) : bool
    {
        return array_key_exists($identifier, $this->consumers);
    }
}