<?php

namespace FiloBlu\Esb\Model;

use DateTime;
use FiloBlu\Esb\Api\Data\MessageInterface;
use FiloBlu\Esb\Api\Data\QueueItemInterface;
use FiloBlu\Esb\Api\Data\StatusInterface;
use Magento\Framework\Api\ExtensibleDataInterface;

/**
 * Class QueueItem
 * @package FiloBlu\Esb\Model
 */
class QueueItem implements QueueItemInterface, ExtensibleDataInterface
{
    /**
     * @var int
     */
    protected $id;
    /**
     * @var int
     */
    protected $priority;
    /**
     * @var string
     */
    protected $event;
    /**
     * @var StatusInterface
     */
    protected $status;
    /**
     * @var MessageInterface
     */
    protected $message;
    /**
     * @var DateTime
     */
    protected $executableAfter;
    /**
     * @var DateTime|null
     */
    protected $publishedAt;
    /**
     * @var DateTime|null
     */
    protected $executedAt;
    /**
     * @var DateTime
     */
    protected $finishedAt;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     * @return QueueItemInterface
     */
    public function setId($id) : QueueItemInterface
    {
        $this->id = $id;
        return $this;
    }

    /**
     * @return int
     */
    public function getPriority()
    {
        return $this->priority;
    }

    /**
     * @param int $priority
     * @return QueueItemInterface
     */
    public function setPriority($priority) : QueueItemInterface
    {

        $this->priority = (int)$priority;
        return $this;
    }

    /**
     * @return string
     */
    public function getEvent()
    {
        return $this->event;
    }

    /**
     * @param string $event
     * @return QueueItemInterface
     */
    public function setEvent($event) : QueueItemInterface
    {
        $this->event = $event;
        return $this;
    }

    /**
     * @return StatusInterface
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param StatusInterface $status
     * @return QueueItemInterface
     */
    public function setStatus(StatusInterface $status) : QueueItemInterface
    {

        $this->status = $status;
        return $this;
    }

    /**
     * @return MessageInterface
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * @param MessageInterface $message
     * @return QueueItemInterface
     */
    public function setMessage(MessageInterface $message) : QueueItemInterface
    {
        $this->message = $message;
        return $this;
    }

    /**
     * @return DateTime
     */
    public function getExecutableAfter()
    {
        return $this->executableAfter;
    }

    /**
     * @param DateTime $dateTime
     * @return $this
     */
    public function setExecutableAfter(DateTime $dateTime = null) : QueueItemInterface
    {
        $this->executableAfter = $dateTime;
        return $this;
    }

    /**
     * @return DateTime
     */
    public function getPublishedAt()
    {
        return $this->publishedAt;
    }

    /**
     * @param DateTime|null $publishedAt
     * @return QueueItemInterface
     */
    public function setPublishedAt(DateTime $publishedAt = null) : QueueItemInterface
    {
        $this->publishedAt = $publishedAt;
        return $this;
    }

    /**
     * @return DateTime
     */
    public function getExecutedAt()
    {
        return $this->executedAt;
    }

    /**
     * @param DateTime|null $executedAt
     * @return QueueItemInterface
     */
    public function setExecutedAt(DateTime $executedAt = null) : QueueItemInterface
    {
        $this->executedAt = $executedAt;
        return $this;
    }

    /**
     * @return DateTime
     */
    public function getFinishedAt()
    {
        return $this->finishedAt;
    }

    /**
     * @param DateTime $finishedAt
     * @return $this
     */
    public function setFinishedAt(DateTime $finishedAt = null) : QueueItemInterface
    {
        $this->finishedAt = $finishedAt;
        return $this;
    }
}